/*
 * Copyright 2015, The Querydsl Team (http://www.querydsl.com/team)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.mysema.query.jpa.domain;

import java.util.Map;

import javax.persistence.*;

/**
 * The Class Show.
 */
@Entity
@Table(name="show_")
public class Show {

    @Id
    long id;

    @ElementCollection
    @MapKeyColumn(name="acts_key")
    public Map<String, String> acts;

    @ManyToOne
    public Show parent;

    public Show() {}

    public Show(int id) {
        this.id = id;
    }

}
